Index: apps/app_voicemail.c
===================================================================
--- apps/app_voicemail.c	(revision 32039)
+++ apps/app_voicemail.c	(working copy)
@@ -314,6 +314,7 @@
 static char VM_SPOOL_DIR[AST_CONFIG_MAX_PATH];
 
 static char ext_pass_cmd[128];
+static char ext_pass_notify_cmd[128];
 
 static char *tdesc = "Comedian Mail (Voicemail System)";
 
@@ -643,6 +644,14 @@
 	return res;
 }
 
+static void vm_change_password_shellnotify(struct ast_vm_user *vmu, char *newpassword)
+{
+	char buf[255];
+	snprintf(buf,255,"%s %s %s %s",ext_pass_notify_cmd,vmu->context,vmu->mailbox,newpassword);
+	if (!ast_safe_system(buf))
+		ast_copy_string(vmu->password, newpassword, sizeof(vmu->password));
+}
+
 static void vm_change_password(struct ast_vm_user *vmu, const char *newpassword)
 {
 	/*  There's probably a better way of doing this. */
@@ -773,6 +782,9 @@
 	rename(tmpout, tmpin);
 	reset_user_pw(vmu->context, vmu->mailbox, newpassword);
 	ast_copy_string(vmu->password, newpassword, sizeof(vmu->password));
+	if (ext_pass_notify_cmd) {
+		vm_change_password_shellnotify(vmu->user, newpassword);
+	}
 }
 
 static void vm_change_password_shell(struct ast_vm_user *vmu, char *newpassword)
@@ -6230,6 +6242,13 @@
 		if ((extpc = ast_variable_retrieve(cfg, "general", "externpass"))) {
 			ast_copy_string(ext_pass_cmd,extpc,sizeof(ext_pass_cmd));
 		}
+		
+		/* External password changing notify command */
+		if ((extpc = ast_variable_retrieve(cfg, "general", "externpassnotify"))) {
+			ast_copy_string(ext_pass_notify_cmd,extpc,sizeof(ext_pass_cmd));
+		} else {
+			ext_pass_notify_cmd = NULL;
+		}
 
 		/* External voicemail notify application */
 		
